<?php

class OrmNodeCollection {
  
  private $count = NULL;
  
  /**
   * Handles a result set
   * 
   * @param $results MySQLResultSet
   * @param $opts Assoc
   * @return Array
   */
  public function __construct() {
    $this->count = 0;
  }

  /**
   * Adds a node to the collection
   * 
   * @param $node
   * @param $opts Assoc
   * @return Bool
   */
  public function addNode($node) {
    $this->{$this->count} = $node;
    $this->count++;
    return TRUE;
  }
  
  /**
   * Saves all nodes in a OrmNodeCollection object
   * 
   * @return Bool
   */
  public function saveAll() {
    foreach ($this as $prop => $val) {
      if (is_numeric($prop)) {
        $this->{$prop}->save();
      }
    }
    return TRUE;
  }

  /**
   * Deletes all nodes in a OrmNodeCollection object
   * 
   * @return Bool
   */
  public function deleteAll() {
    foreach ($this as $prop => $val) {
      if (is_numeric($prop)) {
        $this->{$prop}->delete();
        if (isset($this->{$prop})) {
          unset($this->{$prop});
        }
      }
    }
    return TRUE;
  }
  
  
  /**
   * Returns node response count
   * 
   * @return Int
   */
  public function getCount() {
    return $this->count;
  }
  
}